#!/usr/bin/ruby

################################################################################
#
# Copyright (c) 2009, Perforce Software, Inc.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1.  Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
# 2.  Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE SOFTWARE, INC. BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# = Description
# 
# Compare db.rev records for inconsistencies in changelist sequence order
#
# = Usage
#
# ruby revCheck.rb <checkpoint>
#
################################################################################

re_db_rev = Regexp.new( '@pv@ \d+ @db.rev@ @(.*)@ (\d+) \d+ \d+ (\d+) \d+ .*')
line1 = $<.gets
line2 = $<.gets
while line2
    if (match1 = re_db_rev.match(line1))
       file1 = match1[1]
       rev1 = match1[2].to_i
       change1 = match1[3].to_i
       if (line2 and match2 = re_db_rev.match(line2))
          file2 = match2[1]
	  rev2 = match2[2].to_i
	  change2 = match2[3].to_i
          if (file1 == file2 and change1 <= change2)
	     printf("Inconsistency found in: %s\n",file1)
          end
       end
    end
    line1 = line2
    line2 = $<.gets
end
